hirom				; hirom addressing
;header				; Comment out if ROM has a header

; SRAM Init (This replace SwTech init)
org $C0BDE4
initRam:
STZ $1E1D,X			; Free SRAM 
INX
CPX #$0008			; Init 8 bytes, one for each upgrade battle number
BNE initRam			; If you want 8 items, change #$0008 to #$0004
BRA continueA

org $C0BDF1
continueA:

; Cursed shield check routine hookup
org $C25FFA
JSL CheckEmptyEquip
BRA continueB

org $C2600C
continueB:

; New code
org $EEAF01			; Free ROM space. I always use the same spot for new code.
					; Make sure to change this if you need to relocate the code.
CheckEmptyEquip:
STA $1440			; Use of free RAM $1440 as temp storing value 
PHA					; Push A and X for the sake of restoring registers 
PHX					; at the end of routine
LDX #$0000
equipLoop:
LDA EquipTableA,X	; Get weapon to upgrade
CMP $1440			; Check if match equipped weapon
BEQ itemFound		; Branch if match
INX					; Increment table index
CPX #$0008			; Check if done 8 items (change this value for bigger/smaller tables)
BNE equipLoop		; If not check next item in table
BRA exit			; If we reach this point no item match so exit
itemFound:
INC $1E1D,X			; Item match so increment its counter
LDA FightsTable,X	; Load battle table value
CMP $1E1D,X			; Check if it equal counter
BEQ fightEqual		; branch if so
BRA exit			; if not we need to win more fights!
fightEqual:
STZ $1E1D,X			; Counter equal number of fights needed so reset counter
LDA #$01
TSB $F0				; Display "uncursed" message at end of fight
LDA EquipTableB,X	; Load upgraded item
PLX			
STA $161F,X			; Store upgraded weapon in place of the old one
PLA
RTL
exit:
PLX
PLA
RTL

; Items to upgrade. Comment out or add lines for more item as well as 
; changing line 36 (Main routine) and 9 (SRAM Init) above if needed.
EquipTableA:
DB $66	; Cursed shield
DB $00	
DB $00
DB $00
DB $00
DB $00
DB $00
DB $00	

; Upgraded items. Number of line must match table above.
EquipTableB:
DB $67	; Paladin Shield
DB $00	
DB $00
DB $00
DB $00
DB $00
DB $00
DB $00

; Number of battles needed to upgrade item
FightsTable:
DB $FF	; 256 battles
DB $FF
DB $FF
DB $FF
DB $FF
DB $FF
DB $FF
DB $FF